<?php

/*

TODO:
	- добавить атоопределение сервера
	- прикрутить любую версию из кэша (опционально)
	- опционально разрешить загрузку недостающих тайлов из инета
	
*/

function xy($digit, $level) {
  $x = 0;
  $y = 0;
  for($i = 1; $i < $level; $i++){
	$x*=2;
	$y*=2;
	switch ($digit[$i]){
	  case "0": 
		$y++;
		break;
	  case "1":
		$x++;
		$y++;
		break;
	  case "2": 
		$x++;
		break;
	}
  } 
  return array ($x,$y);
}
  
function get_tile_path($url) {
  
  debug_log('$url = '.$url);
  
  global $cache;
  
  $regexp = "/(q2|f1|f1c|qp)-(\d+)-(\w)\.(\d+)\.?(\d+)?/";
  
  preg_match_all($regexp, $url, $match);
  
  $path = array();
  for($i = 0; $i < count($match[0]); $i++){
    
	$path[$i] = $cache."Tiles/Earth/";
    
	switch ($match[3][$i]){
	  case "q":
	    $path[$i] .= "Qtrees/".$match[4][$i]."/";
	    break;
	  case "i":
	    $path[$i] .= "Images/";
	    break;
	  case "d":
	    if($match[1][$i] == "f1c") {
          $path[$i] .= "Layers/";
		}
	    else {
          $path[$i] .= "Textures/";
        }
	    $path[$i] .= $match[4][$i]."/";
	    break;
	  case "t":
	    $path[$i] .= "Terrains/";
	    break;
    }
	
	$digit = $match[2][$i];
	$level = strlen($digit);
	list ($x,$y) = xy($digit, $level);
	$path[$i] .= "z".$level."/".floor($x/1024)."/x".$x."/".floor($y/1024)."/".$match[0][$i];
	
  }
  
  debug_log('$path = '.implode(",", $path));
  
  return $path;
}

function get_flatfile_body ($path) {

    $count = count($path);

	if($count == 1) { # одниночный тайл
		if( file_exists($path[0]) ) {
			$body_size = filesize($path[0]);
			$file = fopen($path[0],'rb');
			$body = fread($file, $body_size);
			fclose($file);
			return array ($body, $body_size);
		}
		else { 
			debug_log("Tile not exists: ".$path[0]);
			return array ("", 0);
		}
	}
	else { # паравоз
		$body_size = 1 + 1 + 4*$count;
		$offset = $body_size;
		# получаем размеры тайлов
		for( $i = 0; $i < $count; $i++ ){
			if (file_exists($path[$i])) {
				$tile_size[$i] = filesize($path[$i]);
				$body_size += $tile_size[$i];
			}
			else {
				$tile_size[$i] = 0;
				debug_log("Tile not exists: ".$path[$i]);
			}
		}
		# пишем заголовок
		$body = pack('CC', 0x01, $count);
		for($i=0; $i < $count; $i++){
			$body .= pack('L', $offset);
			$offset += $tile_size[$i];
		}
		# пишем тайлы
		for($i=0; $i < $count; $i++){
			if ($tile_size[$i] > 0) {
				$file = fopen($path[$i], 'rb');
				$body .= fread($file, $tile_size[$i]);
				fclose($file);
			} 
		}
		return array ($body, $body_size);
    } 
}

function get_icon_body ($url) {
     
	 global $cache;
	 
	 list ($body, $body_size) = hdd_read($cache."Tiles/Earth/".$url);
	 
	 return array ($body, $body_size);
}


?>